/**
 * <copyright>
 * Thales MARTE (Copyright (c) THALES 2007 All rights reserved) is free software; you can redistribute itand/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html
 *
 * Thales MARTE is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details. 
 * </copyright>

 *
 * $Id: ConditionalExpressionImpl.java,v 1.2 2007/10/15 09:30:32 fnizou Exp $
 */
package VSL.impl;

import VSL.ConditionalExpression;
import VSL.VSLPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.uml2.uml.ValueSpecification;

import org.eclipse.uml2.uml.internal.impl.ExpressionImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Conditional Expression</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link VSL.impl.ConditionalExpressionImpl#getConditionExpr <em>Condition Expr</em>}</li>
 *   <li>{@link VSL.impl.ConditionalExpressionImpl#getIfTrueExpr <em>If True Expr</em>}</li>
 *   <li>{@link VSL.impl.ConditionalExpressionImpl#getIfFalseExpr <em>If False Expr</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ConditionalExpressionImpl extends ExpressionImpl implements ConditionalExpression {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " Copyright 2007 Thales Research & Technology";

	/**
	 * The cached value of the '{@link #getConditionExpr() <em>Condition Expr</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConditionExpr()
	 * @generated
	 * @ordered
	 */
	protected ValueSpecification conditionExpr = null;

	/**
	 * The cached value of the '{@link #getIfTrueExpr() <em>If True Expr</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIfTrueExpr()
	 * @generated
	 * @ordered
	 */
	protected ValueSpecification ifTrueExpr = null;

	/**
	 * The cached value of the '{@link #getIfFalseExpr() <em>If False Expr</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIfFalseExpr()
	 * @generated
	 * @ordered
	 */
	protected ValueSpecification ifFalseExpr = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionalExpressionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return VSLPackage.Literals.CONDITIONAL_EXPRESSION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValueSpecification getConditionExpr() {
		return conditionExpr;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetConditionExpr(ValueSpecification newConditionExpr, NotificationChain msgs) {
		ValueSpecification oldConditionExpr = conditionExpr;
		conditionExpr = newConditionExpr;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR, oldConditionExpr, newConditionExpr);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConditionExpr(ValueSpecification newConditionExpr) {
		if (newConditionExpr != conditionExpr) {
			NotificationChain msgs = null;
			if (conditionExpr != null)
				msgs = ((InternalEObject)conditionExpr).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR, null, msgs);
			if (newConditionExpr != null)
				msgs = ((InternalEObject)newConditionExpr).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR, null, msgs);
			msgs = basicSetConditionExpr(newConditionExpr, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR, newConditionExpr, newConditionExpr));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValueSpecification getIfTrueExpr() {
		return ifTrueExpr;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetIfTrueExpr(ValueSpecification newIfTrueExpr, NotificationChain msgs) {
		ValueSpecification oldIfTrueExpr = ifTrueExpr;
		ifTrueExpr = newIfTrueExpr;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR, oldIfTrueExpr, newIfTrueExpr);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIfTrueExpr(ValueSpecification newIfTrueExpr) {
		if (newIfTrueExpr != ifTrueExpr) {
			NotificationChain msgs = null;
			if (ifTrueExpr != null)
				msgs = ((InternalEObject)ifTrueExpr).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR, null, msgs);
			if (newIfTrueExpr != null)
				msgs = ((InternalEObject)newIfTrueExpr).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR, null, msgs);
			msgs = basicSetIfTrueExpr(newIfTrueExpr, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR, newIfTrueExpr, newIfTrueExpr));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValueSpecification getIfFalseExpr() {
		return ifFalseExpr;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetIfFalseExpr(ValueSpecification newIfFalseExpr, NotificationChain msgs) {
		ValueSpecification oldIfFalseExpr = ifFalseExpr;
		ifFalseExpr = newIfFalseExpr;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR, oldIfFalseExpr, newIfFalseExpr);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIfFalseExpr(ValueSpecification newIfFalseExpr) {
		if (newIfFalseExpr != ifFalseExpr) {
			NotificationChain msgs = null;
			if (ifFalseExpr != null)
				msgs = ((InternalEObject)ifFalseExpr).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR, null, msgs);
			if (newIfFalseExpr != null)
				msgs = ((InternalEObject)newIfFalseExpr).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR, null, msgs);
			msgs = basicSetIfFalseExpr(newIfFalseExpr, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR, newIfFalseExpr, newIfFalseExpr));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR:
				return basicSetConditionExpr(null, msgs);
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR:
				return basicSetIfTrueExpr(null, msgs);
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR:
				return basicSetIfFalseExpr(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR:
				return getConditionExpr();
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR:
				return getIfTrueExpr();
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR:
				return getIfFalseExpr();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR:
				setConditionExpr((ValueSpecification)newValue);
				return;
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR:
				setIfTrueExpr((ValueSpecification)newValue);
				return;
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR:
				setIfFalseExpr((ValueSpecification)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(int featureID) {
		switch (featureID) {
			case VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR:
				setConditionExpr((ValueSpecification)null);
				return;
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR:
				setIfTrueExpr((ValueSpecification)null);
				return;
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR:
				setIfFalseExpr((ValueSpecification)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case VSLPackage.CONDITIONAL_EXPRESSION__CONDITION_EXPR:
				return conditionExpr != null;
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_TRUE_EXPR:
				return ifTrueExpr != null;
			case VSLPackage.CONDITIONAL_EXPRESSION__IF_FALSE_EXPR:
				return ifFalseExpr != null;
		}
		return super.eIsSet(featureID);
	}

} //ConditionalExpressionImpl