/**
 * <copyright>
 * Thales MARTE (Copyright (c) THALES 2007 All rights reserved) is free software; you can redistribute itand/or modify
 * it under the terms of the Eclipse Public License as published in http://www.eclipse.org/legal/epl-v10.html
 
 * Thales MARTE is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License for more details. 
 * </copyright>
 *
 * $Id: VSLCellEditor.java,v 1.3 2007/10/15 09:57:11 fnizou Exp $
 */
package com.thalesgroup.nfp.rsa.views;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.jface.viewers.DialogCellEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Stereotype;

import com.thalesgroup.nfp.rsa.model.RSAModel;

/**
 * A cell editor calling the VSL Editor.
 * @author T0081227 Francois NIZOU - 6 aot 07 
 *
 */
public class VSLCellEditor extends DialogCellEditor {

	Element element = null;

	Stereotype stereotype = null;

	Property property = null;

	Integer index = null;

	public void setUp(Element element, Stereotype stereotype,
			Property property, Integer index) {
		this.element = element;
		this.stereotype = stereotype;
		this.property = property;
		this.index = index;
	}

	public VSLCellEditor(Composite parent) {
		super(parent);
	}

	@Override
	protected Object openDialogBox(Control cellEditorWindow) {
		RSAModel.instance().HandleStereotypeProperty(element, stereotype,
				property, index);
		Object value = element.getValue(stereotype, property.getName());
		EObject eobject = null;
		if (value instanceof EList) {
			EList eList = (EList) value;
			eobject = (EObject) eList.get(index);
		} else {
			eobject = (EObject) value;
		}

		EClass clazz = eobject.eClass();
		EStructuralFeature sf = clazz.getEStructuralFeature("value");
		
		if (sf != null)
			return eobject.eGet(sf);
		else
			return "";
	}

}
